
/*
 * Copyright (c) 2009 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: blockcopy.S 21 2016-12-02 21:25:59Z buildsa $"

#include <config.h>
#include <version.h>
#include <asm/regdef.h>
#include <asm/mipsregs.h>
#include <asm/addrspace.h>
#include "palodtls.h"

        .set mips32r2
        .set noreorder
        .text

/*
 * a0 = dest
 * a1 = src
 * a2 = len
 */
LEAF(blockcopy)
        addiu   a2, a2, 31
        li      t0, -32
        and     a2, a2, t0              // len = (len + 31) & -32
        beqz    a2, 2f                  // end if len == 0
        addu    a2, a1, a2              // delay slot: a2 = src + len
1:
        lw      t0, 0(a1)               // load 32 bytes
        lw      t1, 4(a1)
        lw      t2, 8(a1)
        lw      t3, 12(a1)
        lw      t4, 16(a1)
        lw      t5, 20(a1)
        lw      t6, 24(a1)
        lw      t7, 28(a1)
        addiu   a1, a1, 32              // src += 32
        sw      t0, 0(a0)               // store 32 bytes
        sw      t1, 4(a0)
        sw      t2, 8(a0)
        sw      t3, 12(a0)
        sw      t4, 16(a0)
        sw      t5, 20(a0)
        sw      t6, 24(a0)
        sw      t7, 28(a0)
        bne     a1, a2, 1b              // loop if src != end
        addiu   a0, a0, 32              // delay slot: dest += 32
2:
        jr      ra
        nop
        END(blockcopy)
