/*
 * Copyright 2010 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: lowlevel_init_sereno.S 21 2016-12-02 21:25:59Z buildsa $"

	.text
	.set noreorder
	.set mips32

LEAF(lowlevel_init)
        /*
         * Disable BECC interrupts (detection and correction are off by default)
         */
        li      t0, 0
        sw      t0, KSEG1ADDR(MISC_MREGS_BE_INT_ECC_ERROR_MSK)
        /*
         * Configure BECC memory mapping (need to do before memory init).
         * Region 0 size must be set based on memory size:
         * for 0-128MB size = 1, for 256MB size = 2, for 512MB size = 3.
         * 
         * Set mem init magic value: 0xda for 128MB, 0xea for 256MB
         */
        lw      t0, KSEG1ADDR(MISC_MREGS_EMULATION)
        li      t1, MISC_EMULATION_SERENOTE
        bne     t0, t1, 1f
        nop
        /* serenote (128MB) settings */
        li      t2, 1
        li      t3, 0x000000da
        b       2f
        nop
1:
        /* ASIC (256MB) settings */
        li      t2, 2
        li      t3, 0x000000ea
2:
        sw      t2, KSEG1ADDR(MISC_MREGS_BE_CFG_TRANSLATE_REGION0_SIZE)
        lw      t2, KSEG1ADDR(MISC_MREGS_BE_CFG_TRANSLATE_REGION0_SIZE) // flush
        /*
         * FPGA-only memory something or other.
         */
        lw      t0, KSEG1ADDR(MISC_MREGS_EMULATION)
        li      t1, MISC_EMULATION_SERENOTE
        bne     t0, t1, mem_refresh
        nop
        li      t0, 0x00000082
        sw      t0, KSEG1ADDR(MISC_MREGS_MEMCTL_TIMING3)
mem_refresh:
        /* Memory refresh is in (later) B versions only */
        lw      t0, KSEG1ADDR(MISC_MREGS_VERSION)
        li      t1, 0xa0
        beq     t0, t1, mem_init
        nop
        li      t0, 1
        sw      t0, KSEG1ADDR(MISC_MREGS_REFRESH_ENABLE)
mem_init:
        sw      t3, KSEG1ADDR(MISC_MREGS_MEMCTL_ADDRCTL)
        li      t0, 0x00000002
        sw      t0, KSEG1ADDR(MISC_MREGS_MEMCTL_DRIVE_CMD_INIT)
        lw      t0, KSEG1ADDR(MISC_MREGS_MEMCTL_STATUS)   // flush

        jr      ra
        nop
        END(lowlevel_init)
