
/*
 * Copyright (c) 2003  Wolfgang Denk <wd@denx.de>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Copyright 2007 Nuova Systems, Inc.  All rights reserved.
 * Copyright 2009-2011 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: start.S 46 2016-12-03 23:17:24Z buildsa $"

#include <config.h>
#include <version.h>
#include <asm/regdef.h>
#include <asm/mipsregs.h>
#include <asm/addrspace.h>
#include <palo/include/misc_regs.h>
#include <palo/include/l2_mregs.h>
#include <palo/include/pcie_mregs.h>
#include <palo/include/intrc_mregs.h>
#include <palo/include/misc_mregs.h>
#include <palo/include/palo_gpio.h>
#include <palo/include/synopsis/dw_memctl.h>
#include <palo/include/synopsis/dw_gpio.h>
#include <palo/fw/mcpu/include/ecpuctx.h>
#include <palo/fw/mcpu/include/palofwimg.h>
#include <palo/fw/mcpu/include/palopostcodes.h>
#include <common/include/newjersey_defs.h>
#include "palodtls.h"

#define RVECENT(f,n)        b f; nop
#define XVECENT(f,bev)      b f; li k0,bev
#define ROM_RESERVED(vec)   b romReserved; li k0, vec

        .set mips32r2
        .set noreorder
        .text

/*******************************************************************************
 * Exception vectors located at 0xbfc00000
 */
        .globl _start
        .ent _start
_start:
        RVECENT(romReset, 0x000)            // reset, NMI (k0 intact)
        ROM_RESERVED(0x008)
        ROM_RESERVED(0x010)
        ROM_RESERVED(0x018)
        ROM_RESERVED(0x020)
        ROM_RESERVED(0x028)
        ROM_RESERVED(0x030)
        ROM_RESERVED(0x038)
        ROM_RESERVED(0x040)
        ROM_RESERVED(0x048)
        ROM_RESERVED(0x050)
        ROM_RESERVED(0x058)
        ROM_RESERVED(0x060)
        ROM_RESERVED(0x068)
        ROM_RESERVED(0x070)
        ROM_RESERVED(0x078)
        ROM_RESERVED(0x080)
        ROM_RESERVED(0x088)
        ROM_RESERVED(0x090)
        ROM_RESERVED(0x098)
        ROM_RESERVED(0x0a0)
        ROM_RESERVED(0x0a8)
        ROM_RESERVED(0x0b0)
        ROM_RESERVED(0x0b8)
        ROM_RESERVED(0x0c0)
        ROM_RESERVED(0x0c8)
        ROM_RESERVED(0x0d0)
        ROM_RESERVED(0x0d8)
        ROM_RESERVED(0x0e0)
        ROM_RESERVED(0x0e8)
        ROM_RESERVED(0x0f0)
        ROM_RESERVED(0x0f8)
        ROM_RESERVED(0x100)
        ROM_RESERVED(0x108)
        ROM_RESERVED(0x110)
        ROM_RESERVED(0x118)
        ROM_RESERVED(0x120)
        ROM_RESERVED(0x128)
        ROM_RESERVED(0x130)
        ROM_RESERVED(0x138)
        ROM_RESERVED(0x140)
        ROM_RESERVED(0x148)
        ROM_RESERVED(0x150)
        ROM_RESERVED(0x158)
        ROM_RESERVED(0x160)
        ROM_RESERVED(0x168)
        ROM_RESERVED(0x170)
        ROM_RESERVED(0x178)
        ROM_RESERVED(0x180)
        ROM_RESERVED(0x188)
        ROM_RESERVED(0x190)
        ROM_RESERVED(0x198)
        ROM_RESERVED(0x1a0)
        ROM_RESERVED(0x1a8)
        ROM_RESERVED(0x1b0)
        ROM_RESERVED(0x1b8)
        ROM_RESERVED(0x1c0)
        ROM_RESERVED(0x1c8)
        ROM_RESERVED(0x1d0)
        ROM_RESERVED(0x1d8)
        ROM_RESERVED(0x1e0)
        ROM_RESERVED(0x1e8)
        ROM_RESERVED(0x1f0)
        ROM_RESERVED(0x1f8)
        XVECENT(romExcHandle, 0x200)        // TLB Refill
        ROM_RESERVED(0x208)
        ROM_RESERVED(0x210)
        ROM_RESERVED(0x218)
        ROM_RESERVED(0x220)
        ROM_RESERVED(0x228)
        ROM_RESERVED(0x230)
        ROM_RESERVED(0x238)
        ROM_RESERVED(0x240)
        ROM_RESERVED(0x248)
        ROM_RESERVED(0x250)
        ROM_RESERVED(0x258)
        ROM_RESERVED(0x260)
        ROM_RESERVED(0x268)
        ROM_RESERVED(0x270)
        ROM_RESERVED(0x278)
        ROM_RESERVED(0x280)
        ROM_RESERVED(0x288)
        ROM_RESERVED(0x290)
        ROM_RESERVED(0x298)
        ROM_RESERVED(0x2a0)
        ROM_RESERVED(0x2a8)
        ROM_RESERVED(0x2b0)
        ROM_RESERVED(0x2b8)
        ROM_RESERVED(0x2c0)
        ROM_RESERVED(0x2c8)
        ROM_RESERVED(0x2d0)
        ROM_RESERVED(0x2d8)
        ROM_RESERVED(0x2e0)
        ROM_RESERVED(0x2e8)
        ROM_RESERVED(0x2f0)
        ROM_RESERVED(0x2f8)
        RVECENT(romCacheErr, 0x300)        // Cache Error
        ROM_RESERVED(0x308)
        ROM_RESERVED(0x310)
        ROM_RESERVED(0x318)
        ROM_RESERVED(0x320)
        ROM_RESERVED(0x328)
        ROM_RESERVED(0x330)
        ROM_RESERVED(0x338)
        ROM_RESERVED(0x340)
        ROM_RESERVED(0x348)
        ROM_RESERVED(0x350)
        ROM_RESERVED(0x358)
        ROM_RESERVED(0x360)
        ROM_RESERVED(0x368)
        ROM_RESERVED(0x370)
        ROM_RESERVED(0x378)
        XVECENT(romExcHandle, 0x380)        // General Exception
        ROM_RESERVED(0x388)
        ROM_RESERVED(0x390)
        ROM_RESERVED(0x398)
        ROM_RESERVED(0x3a0)
        ROM_RESERVED(0x3a8)
        ROM_RESERVED(0x3b0)
        ROM_RESERVED(0x3b8)
        ROM_RESERVED(0x3c0)
        ROM_RESERVED(0x3c8)
        ROM_RESERVED(0x3d0)
        ROM_RESERVED(0x3d8)
        ROM_RESERVED(0x3e0)
        ROM_RESERVED(0x3e8)
        ROM_RESERVED(0x3f0)
        ROM_RESERVED(0x3f8)
        XVECENT(romExcHandle, 0x400)        // Interrupt
        ROM_RESERVED(0x408)
        ROM_RESERVED(0x410)
        ROM_RESERVED(0x418)
        ROM_RESERVED(0x420)
        ROM_RESERVED(0x428)
        ROM_RESERVED(0x430)
        ROM_RESERVED(0x438)
        ROM_RESERVED(0x440)
        ROM_RESERVED(0x448)
        ROM_RESERVED(0x450)
        ROM_RESERVED(0x458)
        ROM_RESERVED(0x460)
        ROM_RESERVED(0x468)
        ROM_RESERVED(0x470)
        ROM_RESERVED(0x478)
        RVECENT(romDebug, 0x480)            // Debug Exception (k0 intact)

/*******************************************************************************
 * Embedded palo firmware image header.
 * This is used for identification, as the outer file header is lost during
 * installation.
 */
        /*
         * PAD to 0x800.
         */
        . =         PALOFW_BOOTHDROFFSET

        .word       PALOFW_BOOTMAGIC
        .space      PALOFW_BOOTHDRSPARE - 4

/*******************************************************************************
 * Common Reset/NMI Vector.
 * We can be here for many reasons:
 *  mCPU out of reset (memory controller uninitialized).
 *  mCPU hardware watchdog (NMI) (memory controller initialized).
 *  eCPU out of reset (memory controller initialized).
 */
romReset:
        mtc0    k0, CP0_DESAVE              // save k0
        mfc0    k0, CP0_STATUS
        ext     k0, k0, STATUSB_NMI, 1
        bnez    k0, romNMI
        nop

        /*
         * Common Reset handler.
         * mCPU goes to the system init and u-boot startup.
         * eCPU vectors through their RAM-located vector (by CPU number).
         */
        mfc0    a0, CP0_EBASE
        andi    a0, 0x3ff                   // isolate CPUNum
        beqz    a0, mcpuReset               // zero is mcpu - do chip reset
        nop

        /*
         * eCPU(n) Reset.
         * Assumption is that RAM is available:  mCPU sets up RAM prior to
         * releasing an eCPU from reset.
         * mCPU has placed the executable code in memory and setup a vector. 
         * Jump through the vector, zeroing the magic on the way out.
         * Status.ERL is set, so kuseg is unmapped, uncached.
         */
        mtc0    zero, CP0_CAUSE             // ensure WP is clear for eCPU
        sll     t0, a0, ECPUCTX_LOG2SIZE    // t0 = &ecpuctx[CPUNum] (kuseg)
        li      t1, ECPUCTX_MAGIC
        lw      t2, ECTX_MAGIC(t0)          // t2 = t0->magic
        bne     t2, t1, ecpuDisable         // bail if not set
        nop
        lw      t2, ECTX_ENTRY(t0)          // t2 = t0->entry
        beqz    t2, ecpuDisable             // bail if not set
        nop
        lw      a0, ECTX_ARG(t0)            // a0 = t0->arg
        move    a1, zero
        move    a2, zero
        jr      t2                          // jump to target code
        sw      zero, ECTX_MAGIC(t0)        // delay slot: t0->magic = 0



/*******************************************************************************
 * NMI handler code.
 * Assumption is that RAM is available:  mCPU sets up RAM prior to enabling the
 * watchdog timer (a source of NMI) or asserting an eCPU NMI programmatically.
 * Status.ERL is set, so kuseg is unmapped and uncached... so we can address
 * low memory via register zero.
 */
romNMI:
        mfc0    k0, CP0_EBASE
        andi    k0, 0x3ff                   // k0 = CPUNum
        sll     k0, ECPUCTX_LOG2SIZE        // k0 = &ecpuctx[CPUNum] (kuseg)
        rotr    k0, k0, 16                  // k0 |= 0xa0000000
        ori     k0, k0, 0xa000
        rotr    k0, k0, 16                  // k0 = &ecpuctx[CPUNum] (kseg1)
        sw      k1, ECTX_NMIK1(k0)          // record k1
        mfc0    k1, CP0_DESAVE              // k1 = original k0
        sw      k1, ECTX_NMIK0(k0)          // record k0

        /*
         * Vector to a registered NMI handler.
         */
        sw      t0, ECTX_NMITMP(k0)         // save t0
        lw      k1, ECTX_NMIMAGIC(k0)       // k1 = ecpuctx[CPUNum].nmimagic
        li      t0, ECPUCTX_NMIMAGIC
        bne     k1, t0, romDefaultNMI       // k1 != magic value
        nop

        lw      t0, ECTX_NMITMP(k0)         // restore t0
        lw      k1, ECTX_NMIVEC(k0)
        beqz    k1, romDefaultNMI           // invalid vector
        nop
        jr      k1                          // jump to registered NMI handler
        nop

/*
 * Default NMI Handler.
 * No escape - wait for watchdog or reset.
 */
romDefaultNMI:
        mfc0    k0, CP0_EBASE
        andi    k0, 0x3ff
        bnez    k0, ecpuDisable
        move    a0, k0                      // delay slot
        li      a0, PALO_POST_ROM_NMI
        b       dieWritePost
        nop

/*******************************************************************************
 * mCPU Reset Handler
 * The memory controller is uninitialized.
 * Memory initialization and system startup.
 */
mcpuReset:
        /* 
         * CP0 registers.
         */
        mtc0    zero, CP0_CAUSE

        li      t0, ST0_BEV
        mtc0    t0, CP0_STATUS

        li      t0, CONF_CM_UNCACHED
        mtc0    t0, CP0_CONFIG

        mtc0    zero, CP0_SRSCTL
        mtc0    zero, CP0_COUNT
        mtc0    zero, CP0_COMPARE
        mtc0    zero, CP0_PERFORMANCE
        mtc0    zero, CP0_PERFORMANCE1

        move    k1, zero                    // clear crash flag

        /*
         * Initialize GOT pointer.
         */
        bal     1f
        nop
        .word   _GLOBAL_OFFSET_TABLE_
1:
        move    gp, ra
        lw      t1, 0(ra)
        move    gp, t1

        /*
         * Initialize register-based stack.
         */
        PUSHINIT

#ifdef CONFIG_BASE_CRUZ
        /*
         * Check the PLLs.  It is fatal if they have not locked.
         */
        BAL     (cruz_check_plls)
        nop
        bnez    v0, dieWritePost
        nop

#endif

        /*
         * Flash speed-up.
         */
        lw      t0, KSEG1ADDR(MISC_MREGS_EMULATION)
#if defined CONFIG_BASE_PALO
        li      t1, MISC_EMULATION_PALO
        beq     t0, t1, noflshspdup         // no M29 value for Palo yet
        nop
        li      t0, 0x00841942              // FPGA value
#elif defined CONFIG_BASE_SERENO
        li      t1, MISC_EMULATION_ASIC
        beq     t0, t1, 1f
        nop
        li      t0, 0x00841942              // FPGA value
        b       flshspdup
        nop
1:
	li	t0, 0x00cd3759              // ASIC value (t_wr=3)
#elif defined CONFIG_BASE_CRUZ
        li      t1, MISC_EMULATION_ASIC
        beq     t0, t1, 1f
        nop
        li      t0, 0x00cd3559              // FPGA value (default)
        b       flshspdup
        nop
1:
        /*
         * ASIC value from Randy.
         * Tested on Spansion and Macronix parts.
         *  t_prc=5     (default 9)
         *  t_bta=4     (default 5)
         *  t_wp=16     (default 13)
         *  t_wr=3      (default 1)
         *  t_as=3      (default 1)
         *  t_rc=25     (default 25)
         */
	li	t0, 0x00ac43d9
#endif /* CONFIG_BASE */

flshspdup:
        li      t1, KSEG1ADDR(MEMCTL_SMTMGR_SET0)
        sw      t0, 0(t1)                   // SMTMGR_SET0
        sw      t0, 4(t1)                   // SMTMGR_SET1
        sw      t0, 8(t1)                   // SMTMGR_SET2
        lw      t0, 8(t1)                   // flush

noflshspdup:
#ifdef CONFIG_BASE_CRUZ
        /*
         * Configure the spare pins as flash chip-selects A24 and A25.
         * Set bits 2:1 of the 'cfg' field within misc_cfg_pin_spare.
         */
        lw      t0, KSEG1ADDR(MISC_MREGS_CFG_PIN_SPARE)
        ori     t0, 6 << MISC_MREGS_CFG_PIN_SPARE_CFG_SHIFT;
        sw      t0, KSEG1ADDR(MISC_MREGS_CFG_PIN_SPARE)
#endif
        /*
         * Skip spare-pin-reset, PCIe and memory initialization if running
         * from RAM.
         * Keep the "running in RAM" flag in s0.
         */
        li      s0, 0x10000000
        and     s0, s0, ra
        beqz    s0, skip_if_ram1
        nop

#if defined CONFIG_BASE_PALO
        /*
         * If this is a real Palo ASIC board (Baylands or PaloAlto) then
         * arm the spare pin outputs to the reset FPGA.  This ensures
         * that, should Palo reset, the external FPGA will also reset
         * the FLASH.
         */
        lw      t0, KSEG1ADDR(MISC_MREGS_EMULATION)
        li      t1, MISC_EMULATION_PALO
        bne     t0, t1, nosparepin
        nop
        li      t0, 0xf
        li      t1, KSEG1ADDR(MISC_MREGS_CFG_PIN_SPARE)
        sw      t0, 0(t1)

nosparepin:
#endif /* CONFIG_BASE_PALO */

#ifdef CONFIG_BASE_CRUZ
        /*
         * Montclair (New Jersey): Announce that u-boot has started.
         * 2-bit code 2.
         */
        BAL     (lowlevel_is_montclair)
        nop
        beqz    v0, 1f                      // branch if not NJ
        nop
        BAL     (montclair_write_gpiopost)
        li      a0, NJ_CRUZPOST_STARTED     // delay slot
1:
#endif

        /*
         * Perform early PCIe init.
         */
        BAL     (pcie_lowlevel_init)
        nop

        /* 
         * Initialize the memory subsystem.
         * This disables the L2 cache, and initializes the memory controller
         * with ECC enabled.
         */
        BAL     (lowlevel_init)
        nop

skip_if_ram1:
        /*
         * Initialize and enable the caches.
         * This also initializes the first
	 * <DCACHE_SIZE> of RAM (including ECC) and
         * returns with KSEG0 cacheable.
         */
        BAL     (mips_cache_reset)
        nop

        /*
         * If we're not running from RAM, and we're not running under
         * simulation, initialize memory's ECC.
         */
        beqz    s0, skip_if_ram2            // last use of the flag in s0
        nop

#ifdef MISC_EMULATION_SIM
        li      t0, KSEG1ADDR(MISC_MREGS_EMULATION)
        lw      t0, 0(t0)
        li      t1, MISC_EMULATION_SIM
        beq     t0, t1, skip_if_ram2
        nop
#endif // MISC_EMULATION_SIM	

        BAL     (ecc_init)
        nop

        /*
         * Skip POST if fast-boot is requested.
         */
        la      a0, fastboot            // find the "fastboot=" env var
        BAL     (findvar)
        nop
        beqz    v0, run_post            // returned NULL
        nop
        lb      t0, 0(v0)               // read char
        xori    t0, t0, '1'             // == '1'?
        beqz    t0, skip_post           // yes, skip post
        nop

run_post:
        /*
         * Run POST.
         * Returns v0: zero for success or 0xdeadbeef for failure.
         *         a0: failing POST code.
         */
        BAL     (mcpu_post)
        nop
        li      t0, 0xdeadbeef
        beq     v0, t0, dieWritePost
        nop

skip_post:
        /*
         * Enable and initialize the L2 cache.
         */
#ifdef CONFIG_BASE_PALO
        li      t0, KSEG1ADDR(L2_MREGS_MASTER)
        li      t1, 1
        sw      t1, 0(t0)
        li      t0, KSEG1ADDR(L2_MREGS_INITIALIZE)
        li      t1, 0x1ff
        sw      t1, 0(t0)
#elif defined CONFIG_BASE_SERENO
        li      t0, 0x000001ff
        sw      t0, KSEG1ADDR(L2_MREGS_INITIALIZE)
        li      t0, 0x00000014
        sw      t0, KSEG1ADDR(L2_MREGS_REJOINING)
        /* entry 0 */
        li      t0, 0x00000013
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY0_FORCE)
        li      t0, 0xf0000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY0_ADDR_MASK_LO)
        li      t0, 0x0001ffff
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY0_ADDR_MASK_HI)
        li      t0, 0x00000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY0_ADDR_VALUE_LO)
        li      t0, 0x00010000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY0_ADDR_VALUE_HI)
        /* entry 1 */
        li      t0, 0x00000011
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY1_FORCE)
        li      t0, 0xf8000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY1_ADDR_MASK_LO)
        li      t0, 0x0001ffff
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY1_ADDR_MASK_HI)
        li      t0, 0x18000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY1_ADDR_VALUE_LO)
        li      t0, 0x00010000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY1_ADDR_VALUE_HI)
        /* entry 2 */
        li      t0, 0x00000011
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY2_FORCE)
        li      t0, 0xfff00000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY2_ADDR_MASK_LO)
        li      t0, 0x0001ffff
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY2_ADDR_MASK_HI)
        li      t0, 0x17f00000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY2_ADDR_VALUE_LO)
        li      t0, 0x00010000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY2_ADDR_VALUE_HI)
        /* entry 3 */
        li      t0, 0x00000024
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY3_FORCE)
        li      t0, 0x00000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY3_ADDR_MASK_LO)
        li      t0, 0x00018000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY3_ADDR_MASK_HI)
        li      t0, 0x00000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY3_ADDR_VALUE_LO)
        li      t0, 0x00000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY3_ADDR_VALUE_HI)
        /* entry 4 */
        li      t0, 0x00000024
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY4_FORCE)
        li      t0, 0x00000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY4_ADDR_MASK_LO)
        li      t0, 0x00018000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY4_ADDR_MASK_HI)
        li      t0, 0x00000000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY4_ADDR_VALUE_LO)
        li      t0, 0x00018000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY4_ADDR_VALUE_HI)
        /* Set remaining unused entries to non-zero */
        li      t0, 0xfffff000
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY5_ADDR_VALUE)
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY6_ADDR_VALUE)
        sw      t0, KSEG1ADDR(L2_MREGS_ATTR_CTL_ENTRY7_ADDR_VALUE)
#elif defined CONFIG_BASE_CRUZ
        li      t0, 0x1ff
        sw      t0, KSEG1ADDR(L2H_MREGS_INITIALIZE)
        li      t0, 0x14
        sw      t0, KSEG1ADDR(L2H_MREGS_REJOINING)
        li      t0, 3
        sw      t0, KSEG1ADDR(L2H_MREGS_MASTER)
        li      t0, 0x1ff
        sw      t0, KSEG1ADDR(L2M_MREGS_INITIALIZE)
        li      t0, 3
        sw      t0, KSEG1ADDR(L2M_MREGS_MASTER)
#else
#error  Must define a CONFIG_BASE
#endif /* CONFIG_BASE */

skip_if_ram2:
        /* Set up temporary stack.
         */
        li      sp, CFG_SDRAM_BASE + CFG_INIT_SP_OFFSET

        /* Continue in 'C'.
         */
        la      t9, board_init_f
        j       t9
        nop
        .end    _start

        .section ".rodata"
fastboot:
        .ascii  "fastboot=\000"

        .text

/*
 * void relocate_code (addr_sp, gd, addr_moni)
 *
 * This "function" does not return, instead it continues in RAM
 * after relocating the monitor code.
 *
 * a0 = addr_sp
 * a1 = gd
 * a2 = destination address
 */
        .globl  relocate_code
        .ent    relocate_code
relocate_code:
        move    sp, a0                      // Set new stack pointer

        move    s0, a1
        move    s1, a2

        /*
         * Block copy.
         */
        move    a0, a2                      // a0 = dest
        li      a1, CFG_MONITOR_BASE        // a1 = start
        la      t0, in_ram
        lw      t0, -12(t0)                 // t0 <-- uboot_end_data
        subu    a2, t0, a1                  // a2 = length (end - start)
        BAL     (blockcopy)
        nop

        /*
         * Flush the data cache.
         */
        BAL     (flush_cache)
        nop

        /*
         * Fix GOT pointer:
         *
         * New GOT-PTR = (old GOT-PTR - CFG_MONITOR_BASE) + Destination Address
         */
        move    t6, gp
        subu    gp, CFG_MONITOR_BASE
        addu    gp, s1                      // gp now adjusted
        subu    t6, gp, t6                  // t6 <-- relocation offset

        /*
         * Jump to where we've relocated ourselves.
         */
        addiu   t0, s1, in_ram - _start
        j       t0
        nop

        .word   uboot_end_data
        .word   uboot_end
        .word   num_got_entries

in_ram:
        /*
         * Now we want to update GOT.
         */
        lw      t3, -4(t0)                  // t3 <-- num_got_entries
        addiu   t4, gp, 8                   // Skipping first two entries.
        li      t2, 2
1:
        lw      t1, 0(t4)
        beqz    t1, 2f
        addu    t1, t6                      // delay slot
        sw      t1, 0(t4)
2:
        addiu   t2, 1
        blt     t2, t3, 1b
        addiu   t4, 4                       // delay slot

        /*
         * Clear BSS.
         */
        lw      t1, -12(t0)                 // t1 <-- uboot_end_data
        lw      t2, -8(t0)                  // t2 <-- uboot_end
        addu    t1, t6                      // adjust pointers
        addu    t2, t6

        subu    t1, 4
1:      addiu   t1, 4
        bltl    t1, t2, 1b
        sw      zero, 0(t1)                 // delay slot

        move    a0, s0
        la      t9, board_init_r
        j       t9
        move    a1, s1                      // delay slot

        .end    relocate_code

/*******************************************************************************
 * Debug Exception.
 * We can only get here if there's no EJTAG probe, yet we still get either a
 * debug interrupt, or we're programmatically triggered (e.g. SDBBP
 * instruction).
 *
 * Calistoga may see spurious external debug interrupts which, if they occur
 * before the memory controller has been initialized, will cause us to hang.
 * This is avoided by explicitly checking for mcpu & DINT.  Otherwise we
 * let DINT through so the suprious interrupt can be counted.
 *
 * The assumption is that however we got here, the mCPU has already set up
 * the memory controller and there is probably a registered debug handler.
 */
romDebug:
        mtc0    k0, CP0_DESAVE              // save k0
        mfc0    k0, CP0_EBASE
        andi    k0, 0x3ff                   // k0 = CPUNum
        bnez    k0, 2f                      // branch if not mcpu
        nop

        /*
         * For mcpu, check for the debug interrupt (Debug bit 5; DINT) and
         * return immediately if set.  This avoids a pre-DDR-init suprious DINT
         * from hanging on the memory vector read, below.
         */
        mfc0    k0, CP0_DEBUG               // k0 = Debug
        andi    k0, 0x20                    // Debug.DINT set?
        beqz    k0, 1f                      // no
        nop
        mfc0    k0, CP0_DESAVE
        deret

        /*
         * non-DINT mcpu.
         */
1:
        mfc0    k0, CP0_EBASE
        andi    k0, 0x3ff                   // k0 = CPUNum
        /* fall thru */

        /*
         * ecpu or non-DINT mcpu: Look for a vector in RAM.
         */
2:
        sll     k0, ECPUCTX_LOG2SIZE        // k0 = &ecpuctx[CPUNum] (kuseg)
        rotr    k0, k0, 16                  // k0 |= 0xa0000000
        ori     k0, k0, 0xa000
        rotr    k0, k0, 16                  // k0 = &ecpuctx[CPUNum] (kseg1)
        sw      k1, ECTX_DBGK1(k0)          // record k1
        mfc0    k1, CP0_DESAVE              // k1 = original k0
        sw      k1, ECTX_DBGK0(k0)          // record k0

        /*
         * Vector to a registered DBG handler.
         */
        mtc0    k0, CP0_DESAVE              // save k0 (ectx pointer)
        lw      k0, ECTX_DBGMAGIC(k0)       // k0 = ecpuctx[CPUNum].dbgmagic
        li      k1, ECPUCTX_DBGMAGIC
        bne     k0, k1, 1f                  // k0 != magic value
        nop

        mfc0    k0, CP0_DESAVE              // k0 = &ecpuctx[CPUNum] (kseg1)
        lw      k1, ECTX_DBGVEC(k0)
        beqz    k1, 1f                      // invalid vector
        nop
        jr      k1                          // jump to registered DBG handler
        nop

1:
        /*
         * Default - Restore and return.
         */
        mfc0    k0, CP0_DESAVE              // k0 = &ecpuctx[CPUNum] (kseg1)
        lw      k1, ECTX_DBGK1(k0)          // restore original k1
        lw      k0, ECTX_DBGK0(k0)          // restore original k0
        deret                               // return from debug exception

/*******************************************************************************
 * Cache Error Exception.
 */
romCacheErr:
        mfc0    k0, CP0_EBASE
        andi    k0, 0x3ff
        bnez    k0, ecpuDisable
        move    a0, k0                      // delay slot
        li      a0, PALO_POST_ROM_L1CACHE_ERROR
        b       dieWritePost
        nop

/*******************************************************************************
 * Unhandled Vectors.
 */
romReserved:
        mfc0    k0, CP0_EBASE
        andi    k0, 0x3ff
        bnez    k0, ecpuDisable
        move    a0, k0                      // delay slot
        li      a0, PALO_POST_ROM_RESERVED
        b       dieWritePost
        nop

romExcHandle:
        mfc0    k0, CP0_EBASE
        andi    k0, 0x3ff
        bnez    k0, ecpuDisable
        move    a0, k0                      // delay slot
        li      a0, PALO_POST_ROM_EXCEPTION
        b       dieWritePost
        nop

/*******************************************************************************
 * eCPU Disable.
 * If we catch an exception in U-boot for an eCPU, then for now just take
 * it out by going to "wait".
 *
 * We considered setting the cpu_3_reset_hold_cpuN register,
 * but that could (did) hang the entire Palo ASIC if there are
 * outstanding OCP transacations.  This would hang up even the
 * running mcpu, which makes it hard to debug if/how we get here.
 */

        /*
         * Enter with eCPU number (1 or 2) in a0.
         */
ecpuDisable:
	wait
        b       ecpuDisable	// NOTREACHED
        nop

/*******************************************************************************
 * dieWritePost
 * This function is called from a fatal exception handler with the POST
 * code in a0.  It writes the POST code and spins forever.
 * Register k1 is used to record that we have been here before.  If k1 is
 * set to the magic number we just spin.
 */
#define EXC_ALREADY     0x46415445
dieWritePost:
        li      k0, EXC_ALREADY
        beq     k0, k1, 1f
        nop
        move    k1, k0
#ifdef CONFIG_BASE_CRUZ
        /*
         * Montclair (New Jersey) has non-standard handling.
         */
        BAL     (lowlevel_is_montclair)
        nop
        bnez    v0, die_writepost_montclair
        nop
#endif
        lw      a1, KSEG1ADDR(PL_GPIO_DDR(PL_BL_GPIO_CARD_ADDRESS))
        and     a1, a1, ~PL_GPIO_BIT(PL_BL_GPIO_CARD_ADDRESS)
        sw      a1, KSEG1ADDR(PL_GPIO_DDR(PL_BL_GPIO_CARD_ADDRESS))
        sync
        lw      a1, KSEG1ADDR(PL_GPIO_EXT(PL_BL_GPIO_CARD_ADDRESS))
        and     a1, a1, PL_GPIO_BIT(PL_BL_GPIO_CARD_ADDRESS)
        sltu    a1, zero, a1
        BAL     (booti2c_write_post_code)
        nop
1:      
#if defined CONFIG_BASE_PALO || defined CONFIG_BASE_SERENO
        /*
         * Allow a host reset to reset us.
         */
        li      t0, 1
        sw      t0, KSEG1ADDR(MISC_MREGS_PCIE_FORCE_RESET_OK)
#endif // CONFIG_BASE

        /*
         * Spin forever.
         */
2:      wait
        b       2b
        nop

#ifdef CONFIG_BASE_CRUZ
die_writepost_montclair:
        /*
         * Montclair (New Jersey) has a fixed card address of 1.
         */
        BAL     (booti2c_write_post_code)
        li      a1, 1                       // delay slot: card address = 1

        /*
         * Write the fatal error gpio post code
         */
        BAL     (montclair_write_gpiopost)
        li      a0, NJ_CRUZPOST_FAILED      // delay slot

        /*
         * Spin forever.
         */
1:      wait
        b       1b
        nop

/*
 * Check the Cruz B PLLs are locked.
 */
LEAF(cruz_check_plls)
        li      v0, 0                                   // assume success
        lw      t0, KSEG1ADDR(MISC_MREGS_EMULATION)
        li      t1, MISC_EMULATION_CRUZ                 // is ASIC?
        bne     t0, t1, 2f                              // no
        nop
        lw      t0, KSEG1ADDR(MISC_MREGS_VERSION)
        li      t1, 0xa0                                // Cruz A?
        beq     t0, t1, 2f                              // yes
        nop
        /* Cruz B */
        lw      t0, KSEG1ADDR(MISC_MREGS_PLMI_PLL_CPU_LOCK)
        lw      t1, KSEG1ADDR(MISC_MREGS_PLMI_PLL_DDR_LOCK)
        and     t0, t1
        lw      t1, KSEG1ADDR(MISC_MREGS_PLMI_PLL_CORE_LOCK)
        and     t0, t1
        andi    t0, 1 << MISC_MREGS_PLMI_PLL_CPU_LOCK__SHIFT
        bnez    t0, 2f
        nop
1:
        li      v0, -1
2:
        jr      ra
        nop
        END(cruz_check_plls)

/*
 * Montclair (New Jersey) Write GPIO POST
 * Configure the POST_STATUS GPIOs to output and emit the provided code.
 * Input:       a0 = 2-bit post code.
 */
LEAF(montclair_write_gpiopost)
        /*
         * Write Data out value
         */
        lw      t0, KSEG1ADDR(PL_GPIO_DR(PL_MC_GPIO_POST_STATUS_0))
        and     t0, ~PL_GPIO_BIT(PL_MC_GPIO_POST_STATUS_0)
        andi    t1, a0, 1
        beqz    t1, 1f
        nop
        ori     t0, PL_GPIO_BIT(PL_MC_GPIO_POST_STATUS_0)
1:
        sw      t0, KSEG1ADDR(PL_GPIO_DR(PL_MC_GPIO_POST_STATUS_0))

        lw      t0, KSEG1ADDR(PL_GPIO_DR(PL_MC_GPIO_POST_STATUS_1))
        and     t0, ~PL_GPIO_BIT(PL_MC_GPIO_POST_STATUS_1)
        andi    t1, a0, 2
        beqz    t1, 1f
        nop
        ori     t0, PL_GPIO_BIT(PL_MC_GPIO_POST_STATUS_1)
1:
        sw      t0, KSEG1ADDR(PL_GPIO_DR(PL_MC_GPIO_POST_STATUS_1))

        /*
         * Configure the POST_STATUS GPIOs to output.
         */
        lw      t0, KSEG1ADDR(PL_GPIO_DDR(PL_MC_GPIO_POST_STATUS_0))
        ori     t0, PL_GPIO_BIT(PL_MC_GPIO_POST_STATUS_0)
        sw      t0, KSEG1ADDR(PL_GPIO_DDR(PL_MC_GPIO_POST_STATUS_0))
        lw      t0, KSEG1ADDR(PL_GPIO_DDR(PL_MC_GPIO_POST_STATUS_1))
        ori     t0, PL_GPIO_BIT(PL_MC_GPIO_POST_STATUS_1)
        sw      t0, KSEG1ADDR(PL_GPIO_DDR(PL_MC_GPIO_POST_STATUS_1))

        jr      ra
        nop
        END(montclair_write_gpiopost)
#endif
