
/*
 * Copyright (c) 2008 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: arb.h 18312 2008-09-10 02:10:23Z davidc $"

#ifndef _PCA9541_H_
#define _PCA9541_H_

/*
 * PCA9541 Registers
 */
#define ARB_CON             0x01        // Control register
#define ARB_ISTAT           0x02        // Interrupt status register
#define ARB_AUTOINC         0x10        // Auto-increment register

/*
 * Control Register.
 */
#define ARB_CON_NTESTON     0x80        // interrupt the other master
#define ARB_CON_BUSINIT     0x10        // perform a bus initialization
#define ARB_CON_NBUSON      0x08
#define ARB_CON_BUSON       0x04
#define ARB_CON_NMYBUS      0x02
#define ARB_CON_MYBUS       0x01

#define ARB_CON_OWNERFLAGS  0x0f


/*
 * Interrupt Status Register.
 */
#define ARB_ISTAT_NMYTEST   0x80        // interrupt generated by other master
#define ARB_ISTAT_BUSINIT   0x02        // BUSINIT complete
#define ARB_ISTAT_BUSLOST   0x08        // BUS was lost

#endif /* _ARB_H_ */
