
/*
 * Copyright 2010 Cisco Systems, Inc.  All rights reserved.
 */
#ident "$Id: ubootenv.h 6 2016-12-02 03:26:55Z buildsa $"

#ifndef _PALO_UBOOTENV_H_
#define _PALO_UBOOTENV_H_

/*
 * The size of the U-Boot environment is fixed for each type of ASIC regardless
 * of the type of flash they use.
 */
#define PALO_UBOOT_PALO_ENV_SIZE    0x8000      // 32K
#define PALO_UBOOT_SERENO_ENV_SIZE  0x20000     // 128K
#define PALO_UBOOT_CRUZ_ENV_SIZE    0x20000     // 128K


/*
 * Convenience macros.
 */
#ifdef CONFIG_BASE_PALO
#define PALO_UBOOT_ENV_SIZE         PALO_UBOOT_PALO_ENV_SIZE
#endif
#ifdef CONFIG_BASE_SERENO
#define PALO_UBOOT_ENV_SIZE         PALO_UBOOT_SERENO_ENV_SIZE
#endif
#ifdef CONFIG_BASE_CRUZ
#define PALO_UBOOT_ENV_SIZE         PALO_UBOOT_CRUZ_ENV_SIZE
#endif

#define PALO_UBOOT_ENV_DATA_SIZE    (PALO_UBOOT_ENV_SIZE - sizeof (u_int32_t))

#ifndef __ASSEMBLY__
typedef struct {
    u_int32_t       crc;
    char            data[PALO_UBOOT_ENV_DATA_SIZE];
} palo_ubootenv_t;
#endif

#endif
