/*
 * Copyright 2009 Cisco Systems, Inc.  All Rights Reserved.
 */
#ident "$Id: cruz_defs.h 46 2016-12-03 23:17:24Z buildsa $"

#ifndef _CRUZ_CRUZ_DEFS_H_
#define _CRUZ_CRUZ_DEFS_H_

#define PALO_MAX_VNIC       2048    /* Maximum number of vnics */
#define PALO_MAX_LIF        2048    /* Maximum number of lifs */
#define PALO_MAX_WQ         8192    /* Maximum number of work queues */
#define PALO_MAX_CQ         8192    /* Maximum number of completion queues */
#define PALO_MAX_RQ         8192    /* Maximum number of receive queues */
#define PALO_MAX_INTR       12288   /* Maximum number of interrupts */
#define PALO_MAX_ECPU       5       /* Maximum number of palo ecpus */
#define PALO_MAX_FCPU       4       /* Maximum number of palo fcpus */
#define PALO_MAX_LUNMAP     256     /* Maximum number of lunmaps per vnic */
#define PALO_MAX_UIF        2       /* Maximum number of uplink interfaces */
#define PALO_MAX_UIFPORT    4       /* Maximum number of uif sub-ports */
#define PALO_MAX_BAR        512     /* Maximum number of PCI Bars */
#define PALO_MAX_HOSTS      16      /* Maximum number of hosts */
#define PALO_MAX_HIDS       16      /* Maximum number of hids */
#define PALO_MAX_INTR_GRP   256     /* Maximum number of interrupt groups */
#define PALO_MAX_GRPINT_MBR 32      /* Maximum number of members per intr grp */
#define PALO_MAX_PKT_SIZE   9208    /* Maximum egress packet size */

#define PALO_MCPU_ID        0       /* mcpu uses processor 0 */
#define PALO_FCPU1_ID       1       /* fcpu uses processor 1 */
#define PALO_FCPU2_ID       2       /* fcpu uses processor 2 */
#define PALO_FCPU3_ID       3       /* fcpu uses processor 3 */
#define PALO_FCPU4_ID       4       /* fcpu uses processor 4 */
#define PALO_MAX_FT         16      /* Maximum number of flow tables */

#define PALO_QUEUE_DESC_SIZE    16  /* byte size of a palo queue desc. */
#define PALO_QUEUE_RING_ALIGN   512 /* byte alignment of palo queue rings */

#define MAX_SNIC_PER_ECPU       4   /* Max SNICs per eCPU in New Jersey */		

#define FORCE_LOOPBACK_ENABLE_SHIFT 11  /* force_loopback enable bit */

#endif /* _CRUZ_CRUZ_DEFS_H_ */
