/*
 * Copyright 2006 Nuova Systems, Inc.  All rights reserved.
 * Copyright 2009 Cisco Systems, Inc.  All Rights Reserved.
 */
#ident "$Id: palo_defs.h 46 2016-12-03 23:17:24Z buildsa $"

#ifndef _PALO_PALO_DEFS_H_
#define _PALO_PALO_DEFS_H_

#define PALO_MAX_VNIC       128     /* Maximum number of vnics */
#define PALO_MAX_LIF        128     /* Maximum number of lifs */
#define PALO_MAX_WQ         1024    /* Maximum number of work queues */
#define PALO_MAX_CQ         1024    /* Maximum number of completion queues */
#define PALO_MAX_RQ         1024    /* Maximum number of receive queues */
#define PALO_MAX_INTR       1536    /* Maximum number of interrupts */
#define PALO_MAX_ECPU       3       /* Maximum number of palo ecpus */
#define PALO_MAX_FCPU       2       /* Maximum number of palo fcpus */
#define PALO_MAX_LUNMAP     256     /* Maximum number of lunmaps per vnic */
#define PALO_MAX_UIF        2       /* Maximum number of uplink interfaces */
#define PALO_MAX_UIFPORT    1       /* Maximum number of uif sub-ports */
#define PALO_MAX_BAR        256     /* Maximum number of PCI Bars */
#define PALO_MAX_HOSTS      1       /* Maximum number of hosts */
#define PALO_MAX_HIDS       1       /* Maximum number of hids */
#define PALO_MAX_INTR_GRP   0       /* Maximum number of interrupt groups */
#define PALO_MAX_GRPINT_MBR 0       /* Maixmum number of members per intr grp */

#define PALO_MCPU_ID        0       /* mcpu uses processor 0 */
#define PALO_FCPU1_ID       1       /* fcpu uses processor 1 */
#define PALO_FCPU2_ID       2       /* fcpu uses processor 2 */

#define PALO_QUEUE_DESC_SIZE    16  /* byte size of a palo queue desc. */
#define PALO_QUEUE_RING_ALIGN   512 /* byte alignment of palo queue rings */

#endif /* _PALO_PALO_DEFS_H_ */
