
/*
// -------------------------------------------------------------------------
//
//
//                      (C) COPYRIGHT 2001 SYNOPSYS INC.
//                             ALL RIGHTS RESERVED
//
//
// File    : DW_ahb_memctl_defs.h
// Authors : Pat Murphy
// Created : Wed Jan 16 10:39:12 GMT 2002
// Abstract: Memory map header file for the DW_ahb_memctl peripheral
//
// -------------------------------------------------------------------------
// Revision: $Id: DW_memctl_defs.h,v 1.1 2006/06/21 21:42:36 scott Exp $
// -------------------------------------------------------------------------
*/

#ifndef _DW_MEMCTL_H_
#define _DW_MEMCTL_H_

/*
 * Header file for the DW_ahb_memctl block.
 */

#define DW_MEMCTL_BASE           0x17ff0000

#define MEMCTL_SCONR             (DW_MEMCTL_BASE + 0x00)
#define MEMCTL_STMG0R            (DW_MEMCTL_BASE + 0x04)
#define MEMCTL_STMG1R            (DW_MEMCTL_BASE + 0x08)
#define MEMCTL_SCTLR             (DW_MEMCTL_BASE + 0x0c)
#define MEMCTL_SREFR             (DW_MEMCTL_BASE + 0x10)
#define MEMCTL_SCSLR0_LOW        (DW_MEMCTL_BASE + 0x14)
#define MEMCTL_SCSLR1_LOW        (DW_MEMCTL_BASE + 0x18)
#define MEMCTL_SCSLR2_LOW        (DW_MEMCTL_BASE + 0x1c)
#define MEMCTL_SCSLR3_LOW        (DW_MEMCTL_BASE + 0x20)
#define MEMCTL_SCSLR4_LOW        (DW_MEMCTL_BASE + 0x24)
#define MEMCTL_SCSLR5_LOW        (DW_MEMCTL_BASE + 0x28)
#define MEMCTL_SCSLR6_LOW        (DW_MEMCTL_BASE + 0x2c)
#define MEMCTL_SCSLR7_LOW        (DW_MEMCTL_BASE + 0x30)
#define MEMCTL_SCSLR0_HIGH       (DW_MEMCTL_BASE + 0x34)
#define MEMCTL_SCSLR1_HIGH       (DW_MEMCTL_BASE + 0x38)
#define MEMCTL_SCSLR2_HIGH       (DW_MEMCTL_BASE + 0x3c)
#define MEMCTL_SCSLR3_HIGH       (DW_MEMCTL_BASE + 0x40)
#define MEMCTL_SCSLR4_HIGH       (DW_MEMCTL_BASE + 0x44)
#define MEMCTL_SCSLR5_HIGH       (DW_MEMCTL_BASE + 0x48)
#define MEMCTL_SCSLR6_HIGH       (DW_MEMCTL_BASE + 0x4c)
#define MEMCTL_SCSLR7_HIGH       (DW_MEMCTL_BASE + 0x50)
#define MEMCTL_SMSKR0            (DW_MEMCTL_BASE + 0x54)
#define MEMCTL_SMSKR1            (DW_MEMCTL_BASE + 0x58)
#define MEMCTL_SMSKR2            (DW_MEMCTL_BASE + 0x5c)
#define MEMCTL_SMSKR3            (DW_MEMCTL_BASE + 0x60)
#define MEMCTL_SMSKR4            (DW_MEMCTL_BASE + 0x64)
#define MEMCTL_SMSKR5            (DW_MEMCTL_BASE + 0x68)
#define MEMCTL_SMSKR6            (DW_MEMCTL_BASE + 0x6c)
#define MEMCTL_SMSKR7            (DW_MEMCTL_BASE + 0x70)
#define MEMCTL_CSALIAS0_LOW      (DW_MEMCTL_BASE + 0x74)
#define MEMCTL_CSALIAS1_LOW      (DW_MEMCTL_BASE + 0x78)
#define MEMCTL_CSALIAS0_HIGH     (DW_MEMCTL_BASE + 0x7c)
#define MEMCTL_CSALIAS1_HIGH     (DW_MEMCTL_BASE + 0x80)
#define MEMCTL_CSREMAP0_LOW      (DW_MEMCTL_BASE + 0x84)
#define MEMCTL_CSREMAP1_LOW      (DW_MEMCTL_BASE + 0x88)
#define MEMCTL_CSREMAP0_HIGH     (DW_MEMCTL_BASE + 0x8c)
#define MEMCTL_CSREMAP1_HIGH     (DW_MEMCTL_BASE + 0x90)
#define MEMCTL_SMTMGR_SET0       (DW_MEMCTL_BASE + 0x94)
#define MEMCTL_SMTMGR_SET1       (DW_MEMCTL_BASE + 0x98)
#define MEMCTL_SMTMGR_SET2       (DW_MEMCTL_BASE + 0x9c)
#define MEMCTL_FLASH_TRPDR       (DW_MEMCTL_BASE + 0xa0)
#define MEMCTL_SMCTLR            (DW_MEMCTL_BASE + 0xa4)
#define MEMCTL_SYNC_FLASH_OPCODE (DW_MEMCTL_BASE + 0xa8)
#define MEMCTL_EXN_MODE_REG      (DW_MEMCTL_BASE + 0xac)
#define MEMCTL_SFCONR            (DW_MEMCTL_BASE + 0xb0)
#define MEMCTL_SFCTLR            (DW_MEMCTL_BASE + 0xb4)
#define MEMCTL_SFTMGR            (DW_MEMCTL_BASE + 0xb8)
#define MEMCTL_COMP_TYPE         (DW_MEMCTL_BASE + 0xfc)
#define MEMCTL_COMP_VERSION      (DW_MEMCTL_BASE + 0xf8)
#define MEMCTL_COMP_PARAMS_1     (DW_MEMCTL_BASE + 0xf4)
#define MEMCTL_COMP_PARAMS_2     (DW_MEMCTL_BASE + 0xf0)

#define MEMCTLMEMCTL_PING_1BIT_WR       (MEMCTL_SCONR)

#define CC_MEMCTL_VER_1_2A_COMPATIABLE_MODE        0
#define CC_MEMCTL_H_DATA_WIDTH                     32
#define CC_MEMCTL_H_ADDR_WIDTH                     32
#define CC_MEMCTL_PIPE_ADDRESS_DECODER             0
#define CC_MEMCTL_ADDR_FIFO_DEPTH                  8
#define CC_MEMCTL_WRITE_FIFO_DEPTH                 8
#define CC_MEMCTL_EBI_INTERFACE                    0
#define CC_MEMCTL_DYNAMIC_RAM_TYPE                 6
#define CC_MEMCTL_ENABLE_STATIC                    1
#define CC_MEMCTL_N_CS                             3
#define CC_MEMCTL_ENABLE_DATABUS_SHARING           0
#define CC_MEMCTL_ENABLE_ADDRBUS_SHARING           0
#define CC_MEMCTL_HARD_WIRE_SDRAM_PARAMETERS       0
#define CC_MEMCTL_HARD_WIRE_SYNCFLASH_PARAMETERS   0
#define CC_MEMCTL_HARD_WIRE_STATIC_PARAMETERS      0
#define CC_MEMCTL_HARD_WIRE_CHIPSELECT_PARAMETERS  0
#define CC_MEMCTL_WRITE_PIPE                       0
#define CC_MEMCTL_READ_PIPE                        2
#define CC_MEMCTL_T_REF                            1040
#define CC_MEMCTL_T_INIT                           8
#define CC_MEMCTL_MAX_S_DATA_WIDTH                 32
#define CC_MEMCTL_S_DATA_WIDTH                     32
#define CC_MEMCTL_MAX_S_ADDR_WIDTH                 16
#define CC_MEMCTL_MAX_S_BANK_ADDR_WIDTH            2
#define CC_MEMCTL_HIGHER_ADDR_FOR_BANKS            0
#define CC_MEMCTL_HIGHER_ADDR_FOR_SF_BANKS         0
#define CC_MEMCTL_NUM_DQS                          4
#define CC_MEMCTL_EXTENDED_MODE_REG                0x0
#define CC_MEMCTL_SM_WRITE_PIPE                    0
#define CC_MEMCTL_MAX_SM_DATA_WIDTH                32
#define CC_MEMCTL_MAX_SM_ADDR_WIDTH                23
#define CC_MEMCTL_T_RPD                            200
#define CC_MEMCTL_CHIP_SELECT0_MEM                 2
#define CC_MEMCTL_REG_SELECT0                      2
#define CC_MEMCTL_CHIP_SELECT0_BASE_ADDRESS        0x80000000
#define CC_MEMCTL_BLOCK_SIZE0                      8
#define CC_MEMCTL_CHIP_SEL0_REMAP_ENABLE           0
#define CC_MEMCTL_CHIP_SEL0_ALIAS_ENABLE           0
#define CC_MEMCTL_CHIP_SELECT0_ALIAS_ADDRESS       0x80000000
#define CC_MEMCTL_CHIP_SELECT0_REMAP_ADDRESS       0x80000000
#define CC_MEMCTL_CHIP_SELECT1_MEM                 2
#define CC_MEMCTL_REG_SELECT1                      0
#define CC_MEMCTL_CHIP_SELECT1_BASE_ADDRESS        0x10000000
#define CC_MEMCTL_BLOCK_SIZE1                      8
#define CC_MEMCTL_CHIP_SEL1_REMAP_ENABLE           0
#define CC_MEMCTL_CHIP_SEL1_ALIAS_ENABLE           0
#define CC_MEMCTL_CHIP_SELECT1_ALIAS_ADDRESS       0x18000000
#define CC_MEMCTL_CHIP_SELECT1_REMAP_ADDRESS       0x12000000
#define CC_MEMCTL_CHIP_SELECT2_MEM                 2
#define CC_MEMCTL_REG_SELECT2                      1
#define CC_MEMCTL_CHIP_SELECT2_BASE_ADDRESS        0x20000000
#define CC_MEMCTL_BLOCK_SIZE2                      8
#define CC_MEMCTL_CHIP_SELECT3_MEM                 2
#define CC_MEMCTL_REG_SELECT3                      1
#define CC_MEMCTL_CHIP_SELECT3_BASE_ADDRESS        0x30000000
#define CC_MEMCTL_BLOCK_SIZE3                      10
#define CC_MEMCTL_CHIP_SELECT4_MEM                 3
#define CC_MEMCTL_REG_SELECT4                      2
#define CC_MEMCTL_CHIP_SELECT4_BASE_ADDRESS        0x40000000
#define CC_MEMCTL_BLOCK_SIZE4                      1
#define CC_MEMCTL_CHIP_SELECT5_MEM                 0
#define CC_MEMCTL_REG_SELECT5                      1
#define CC_MEMCTL_CHIP_SELECT5_BASE_ADDRESS        0x50000000
#define CC_MEMCTL_BLOCK_SIZE5                      1
#define CC_MEMCTL_CHIP_SELECT6_MEM                 0
#define CC_MEMCTL_REG_SELECT6                      1
#define CC_MEMCTL_CHIP_SELECT6_BASE_ADDRESS        0x60000000
#define CC_MEMCTL_BLOCK_SIZE6                      1
#define CC_MEMCTL_CHIP_SELECT7_MEM                 0
#define CC_MEMCTL_REG_SELECT7                      1
#define CC_MEMCTL_CHIP_SELECT7_BASE_ADDRESS        0x70000000
#define CC_MEMCTL_BLOCK_SIZE7                      1
#define CC_MEMCTL_S_ROW_ADDR_WIDTH                 12
#define CC_MEMCTL_S_COL_ADDR_WIDTH                 9
#define CC_MEMCTL_S_BANK_ADDR_WIDTH                2
#define CC_MEMCTL_A8_FOR_PRECHARGE                 0
#define CC_MEMCTL_OPEN_BANKS                       4
#define CC_MEMCTL_CAS_LATENCY                      3
#define CC_MEMCTL_T_RAS_MIN                        6
#define CC_MEMCTL_T_RCD                            3
#define CC_MEMCTL_T_RP                             3
#define CC_MEMCTL_T_WR                             3
#define CC_MEMCTL_T_RCAR                           10
#define CC_MEMCTL_T_XSR                            250
#define CC_MEMCTL_T_RC                             10
#define CC_MEMCTL_NUM_INIT_REF                     8
#define CC_MEMCTL_T_WTR                            1
#define CC_MEMCTL_S_READY_VALID                    0
#define CC_MEMCTL_SF_ROW_ADDR_WIDTH                12
#define CC_MEMCTL_SF_COL_ADDR_WIDTH                9
#define CC_MEMCTL_SF_BANK_ADDR_WIDTH               2
#define CC_MEMCTL_SF_CAS_LATENCY                   3
#define CC_MEMCTL_SF_T_RCD                         3
#define CC_MEMCTL_SF_T_RC                          10
#define CC_MEMCTL_T_RC_SET0                        12
#define CC_MEMCTL_T_AS_SET0                        1
#define CC_MEMCTL_T_WR_SET0                        1
#define CC_MEMCTL_T_WP_SET0                        7
#define CC_MEMCTL_T_BTA_SET0                       1
#define CC_MEMCTL_T_PRC_SET0                       4
#define CC_MEMCTL_PAGE_MODE_SET0                   1
#define CC_MEMCTL_PAGE_SIZE_SET0                   0
#define CC_MEMCTL_READY_MODE_SET0                  0
#define CC_MEMCTL_LOW_FREQ_DEV_SET0                0
#define CC_MEMCTL_SM_READ_PIPE_SET0                0
#define CC_MEMCTL_SM_DATA_WIDTH_SET0               32
#define CC_MEMCTL_T_RC_SET1                        14
#define CC_MEMCTL_T_AS_SET1                        1
#define CC_MEMCTL_T_WR_SET1                        1
#define CC_MEMCTL_T_WP_SET1                        7
#define CC_MEMCTL_T_BTA_SET1                       4
#define CC_MEMCTL_T_PRC_SET1                       16
#define CC_MEMCTL_PAGE_MODE_SET1                   0
#define CC_MEMCTL_PAGE_SIZE_SET1                   0
#define CC_MEMCTL_READY_MODE_SET1                  0
#define CC_MEMCTL_LOW_FREQ_DEV_SET1                0
#define CC_MEMCTL_SM_READ_PIPE_SET1                0
#define CC_MEMCTL_SM_DATA_WIDTH_SET1               32
#define CC_MEMCTL_T_RC_SET2                        12
#define CC_MEMCTL_T_AS_SET2                        1
#define CC_MEMCTL_T_WR_SET2                        1
#define CC_MEMCTL_T_WP_SET2                        7
#define CC_MEMCTL_T_BTA_SET2                       4
#define CC_MEMCTL_T_PRC_SET2                       4
#define CC_MEMCTL_PAGE_MODE_SET2                   1
#define CC_MEMCTL_PAGE_SIZE_SET2                   0
#define CC_MEMCTL_READY_MODE_SET2                  0
#define CC_MEMCTL_LOW_FREQ_DEV_SET2                0
#define CC_MEMCTL_SM_READ_PIPE_SET2                0
#define CC_MEMCTL_SM_DATA_WIDTH_SET2               32
#define CC_MEMCTL_USE_MOBILE_DDR                   0
#define CC_MEMCTL_COMP_VERSION                     0x3237322a
#define CC_MEMCTL_COMP_TYPE                        0x44572110

#endif

